routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();
Route::get('/', 'PostController@index');
Route::get('/home', 'HomeController@index')->name('home');

//user routes
Route::group(['middleware' => ['auth']], function () {
  Route::resource('posts', 'PostController');
  Route::get('my-posts', 'PostController@myPosts')->name('my-posts');
  Route::post('comment/create/{post}', 'PostCommentController@create')->name('comment.create');
});

//admin routes
Route::group(['middleware' => ['auth','admin']], function () {
    Route::get('admin-dashboard', 'AdminController@dashboard')->name('admin.dashboard');
    Route::get('admin/post/edit/{post}', 'AdminController@postEdit')->name('admin.post.edit');
    Route::post('admin/post/update/{post}', 'AdminController@postUpdate')->name('admin.post.update');
    Route::get('admin/report/user-list', 'AdminController@userList')->name('admin.userList');
    Route::get('admin/report/post-list', 'AdminController@postList')->name('admin.postList');
});

app/Http/Controllers/AdminController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Post;
use App\PostComment;
use App\User;
use Auth;

class AdminController extends Controller
{
  public function dashboard()
  {
      $posts = Post::latest()->get();
      return view('admin.dashboard', compact('posts'));
  }

  public function postEdit(Post $post)
  {
      return view('admin.posts_edit', compact('post'));
  }

  public function postUpdate(Request $request, Post $post)
  {
      // Validate posted form data
      $validated = $request->validate([
          'title' => 'required|string|min:5|max:100',
          'description' => 'required|string|min:5|max:2000',
      ]);

      //check the user is the ownwer of the post
      if (Auth::user()->is_admin === 1) {
          // Update Post with validated data
          $post->update($validated);

          // Redirect the user to the created post woth an updated notification
          return redirect()->back()->with('notification', 'Post updated!');
     }

     return redirect()->back()->with('error_message', 'No access Permission!');

  }

  public function userList()
  {
      $users = User::latest()->withCount('posts')->get();
      // return $users;
      return view('admin.user-list', compact('users'));
  }

  public function postList()
  {
      $posts = Post::latest()->withCount('comments')->get();
      // return $posts;
      return view('admin.post-list', compact('posts'));
  }
}

resources/views/admin/dashboard.blade.php
@extends('admin.layout')
@section('content')
<div class="container">
   <div class="row justify-content-center">
      <div class="col-md-12">
         @if (session('notification'))
         <div class="alert alert-success">
            {{ session('notification') }}
         </div>
         @endif
         @if (session('error_message'))
         <div class="alert alert-danger">
            {{ session('error_message') }}
         </div>
         @endif
         <div class="card">
            <div class="card-header">
              <strong> {{ __('All Post') }} </strong>
            </div>
            <div class="card-body">



                <table class="" style="width: 100%;border:1px solid #ccc">
                  <thead>
                    <tr>
                      <th>Title</th>
                      <th>User</th>
                      <th>Created at</th>
                      <th>Action</th>
                    </tr>
                  </thead>
                  <tbody>

                      @forelse($posts as $post)
                      <tr>
                        <td>{{$post->title}}</td>
                        <td>{{$post->user->name}}</td>
                        <td>{{$post->created_at}}</td>
                        <td> <a class="btn btn-sm btn-outline-primary" href="{{ route('admin.post.edit', [$post->id])}}">Edit</a> </td>
                      </tr>
                      @empty
                      <p>No Posts</p>
                      @endforelse


                  </tbody>
                </table>


            </div>
         </div>
      </div>
   </div>
</div>
@endsection

resources/views/admin/layout.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">

    <style media="screen">
    .card-header {
      background-color: #dadad9;
      }
    .card-body {
      background-color: #d7e0d7;
      }

      table, th, td {
        border: 1px solid black;
      }

      th, td {
        padding: 5px;
        text-align: left;
      }

    </style>
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ route('admin.dashboard') }}">
                    <!-- {{ config('app.name', 'Laravel') }} -->Admin Dashboard
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link " href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else



                            @if(Auth::user()->is_admin == 1)
                            <li class="nav-item">
                                <a style="color:white;" class="nav-link btn btn-sm btn-primary" href="{{ route('register') }}">{{ __('Go Back to User Panel') }}</a>
                            </li>
                            @endif

                            <li class="nav-item dropdown">
                                <a id="navbarDropdown2" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                  Reports
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown2">
                                    <a class="dropdown-item" href="{{ route('admin.userList') }}">
                                        {{ __('User list with post count') }}
                                    </a>
                                    <a class="dropdown-item" href="{{ route('admin.postList') }}">
                                        {{ __('Post list with comment count') }}
                                    </a>


                                </div>
                            </li>

                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/admin/post-list.blade.php
@extends('admin.layout')
@section('content')
<div class="container">
   <div class="row justify-content-center">
      <div class="col-md-12">
         @if (session('notification'))
         <div class="alert alert-success">
            {{ session('notification') }}
         </div>
         @endif
         @if (session('error_message'))
         <div class="alert alert-danger">
            {{ session('error_message') }}
         </div>
         @endif
         <div class="card">
            <div class="card-header">
              <strong> {{ __('Posts List With Comments Count') }} </strong>
              <span style="float:right"> <a class="btn btn-sm btn-outline-primary" href="{{ route('admin.dashboard') }}"> Back</a>  </span>
            </div>
            <div class="card-body">



                <table class="" style="width: 100%;border:1px solid #ccc">
                  <thead>
                    <tr>
                      <th>Title</th>
                      <th>Created At</th>
                      <th>Comments Count</th>
                    </tr>
                  </thead>
                  <tbody>

                      @forelse($posts as $post)
                      <tr>
                        <td>{{$post->title}}</td>
                        <td>{{ $post->created_at->diffForHumans() }}</td>
                        <td>{{$post->comments_count}}</td>
                      </tr>
                      @empty
                      <p>No Posts</p>
                      @endforelse


                  </tbody>
                </table>


            </div>
         </div>
      </div>
   </div>
</div>
@endsection

resources/views/admin/posts_edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">

          @if (session('notification'))
          <div class="alert alert-success">
             {{ session('notification') }}
          </div>
          @endif
          @if (session('error_message'))
          <div class="alert alert-danger">
             {{ session('error_message') }}
          </div>
          @endif

            <div class="card">
                <div class="card-header">  <strong> {{ __('Edit Post') }} </strong>
                  <span style="float:right"> <a class="btn btn-sm btn-outline-primary" href="{{ route('admin.dashboard') }}"> Back</a>  </span>

                 </div>

                <div class="card-body">

                  @if ($errors->any())
                      <div class="alert alert-danger">
                          <ul>
                              @foreach ($errors->all() as $error)
                                  <li>{{ $error }}</li>
                              @endforeach
                          </ul>
                      </div>
                  @endif



                  <form method="post" action="{{ route('admin.post.update', [$post->id]) }}">

                  @csrf


                  <div class="form-group">
                      <label class="label">User</label> : {{ $post->user->name }}
                      <span style="color:gray;"> | {{ $post->created_at->diffForHumans() }} </span>
                      <div class="control">

                          <!-- <input class="form-control"  type="text" name="" value="{{ $post->user->name }}" class="input" placeholder=""  maxlength="100" readonly /> -->
                      </div>
                  </div>

                  <div class="form-group">
                      <label class="label">Title</label>
                      <div class="control">
                          <input class="form-control"  type="text" name="title" value="{{ $post->title }}" class="input" placeholder="Title"  maxlength="100"  />
                      </div>
                  </div>

                  <div class="form-group">
                      <label class="label">Description</label>
                      <div class="control">
                          <textarea class="form-control" name="description" class="textarea" placeholder="Description" maxlength="2000"  rows="5">{{ $post->description }}</textarea>
                      </div>
                  </div>


                  <div class="field">
                      <div class="control">
                          <button type="submit" class="btn btn-info">Update</button>
                      </div>
                  </div>

              </form>

                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/user-list.blade.php
@extends('admin.layout')
@section('content')
<div class="container">
   <div class="row justify-content-center">
      <div class="col-md-12">
         @if (session('notification'))
         <div class="alert alert-success">
            {{ session('notification') }}
         </div>
         @endif
         @if (session('error_message'))
         <div class="alert alert-danger">
            {{ session('error_message') }}
         </div>
         @endif
         <div class="card">
            <div class="card-header">
              <strong> {{ __('User List With post Count') }} </strong>
              <span style="float:right"> <a class="btn btn-sm btn-outline-primary" href="{{ route('admin.dashboard') }}"> Back</a>  </span>
            </div>
            <div class="card-body">



                <table class="" style="width: 100%;border:1px solid #ccc">
                  <thead>
                    <tr>
                      <th>First Name</th>
                      <th>Last Name</th>
                      <th>Post Count</th>
                    </tr>
                  </thead>
                  <tbody>

                      @forelse($users as $user)
                      <tr>
                        <td>{{$user->name}}</td>
                        <td>{{$user->second_name}}</td>
                        <td>{{$user->posts_count}}</td>
                      </tr>
                      @empty
                      <p>No Posts</p>
                      @endforelse


                  </tbody>
                </table>


            </div>
         </div>
      </div>
   </div>
</div>
@endsection